#include <stdio.h> 
#include <stdlib.h> 

/** File ou pile ?
 * Chez le boucher le premier dans la File d'attente est le premier servi.
 * Pour une Pile d'assiettes, c'est la dernière assiette rangée qui sera la première à être réutilisée.
 * 
 * Une liste chainée est un ensemble de cellules. Chaque cellule contient un pointeur vers une autre cellule. 
 * La liste est repérée par un "pointeur de tête" qui pointe sur la première cellule et éventuellement par un pointeur dit "pointeur de queue" qui pointe sur la dernière cellule. 
 * 
 * Ici Le pointeur pointe sur la première cellule. L'ajout se fait en tête de liste. S'il faut enlever un élément, ou en ajouter un, c'est en tête de liste que cela se passe. 
 * On est donc en présence de l'implémentation d'une Pile par une Liste avec une seul pointeur sur la tête.
 * 
 * */


typedef struct SCellule {
	double nb ;
	struct SCellule *suiv ;
} TCellule ;

int estPileVide(TCellule *p) ;

TCellule *newPile();

TCellule *newCellule (double nb)  ;

TCellule * insererPile (TCellule *p, double nb) ;

void afficherPile (TCellule *pile) ;
