/**
 * @brief Traitement simple d'images - Manipulation du format BMP
 * @author Ph Lefebvre
 * @arch Linux x86 64 bits
 * @file ex9.c
 * 
*/

#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <bmp.h>


/** Affiche une image au format BMP
@param nom : nom du fichier
*/
void affiImageBMP (const char *nom) {
	char commande [100] ;
	sprintf(commande, "/usr/bin/eog %s &", nom) ;
	system(commande);
}


/** Charge une image
@param fichier : nom du fichier
@return une structure contenant l'image
*/
Image lireImageBMP(const char *fichier) {
	int offsetFic, i, j ;
	int la, ha ;
	FILE *fp ;
	Image im ;
		
	fp = fopen( fichier, "r") ;
	if (fp == NULL) {
		perror("Pb ouverture fichier");
		exit(0) ;
	}
	fread(headBMP, sizeof (char) ,54, fp ) ;  // Entete
	fseek(fp, 10, SEEK_SET ); // Lecture taille entete
	fread(&offsetFic, sizeof (int) ,1, fp ) ;
	if (offsetFic!=54) {
		printf("offset = %d -- PB format BMP\n", offsetFic ) ;
		fclose(fp) ;
		exit(0) ;
	}
	
	fseek(fp, 18, SEEK_SET ); // positionnement sur le champ largeur image
	fread(&la, sizeof (int) ,1, fp ) ; // Lecture largeur image
	fread(&ha, sizeof (int) ,1, fp ) ; // Lecture hauteur image
	
	im= newImage(la, ha) ;
	
	printf(" im.la= %d\n", im.la ) ;
	printf(" im.ha= %d\n", im.ha ) ;
	
	fseek(fp, 54, SEEK_SET ); // Lecture des pixels
	
	
	for (j=0; j<im.ha; j++ )
		for (i=0; i<im.la; i++ ) {
			fread(&(im.b[i][j]), sizeof (char) ,1, fp ); // ordre B, G, R
			fread(&(im.g[i][j]), sizeof (char) ,1, fp );
			fread(&(im.r[i][j]), sizeof (char) ,1, fp );
		}

	fclose(fp) ;
	return (im) ;
}


/** Sauvegarde une image sur disque
@param nomFic : nom du fichier qui sera créé
@param im : structure image en entrée de la fonction
*/
void saveImageBMP(Image im, const char * nomFic) {
	// TO DO !
}
